#! /usr/bin/perl -w

use strict;

sub getdef {
  my($filename,%def) = @_;
  my(%hash);
  my($line);

  open DEFFILE, "<$filename" || die "unable to open file : $ARGV[0]";

  while ($line = <DEFFILE>)
    {
      if ($line =~ /\s*(\w+)\s*=\s*(.*)/)
	{
	  $hash{$1} = $2;
	}
    }
  
  close DEFFILE;

  return %hash;
}

sub getparam {
  my($param,%def) = @_;
  my(%hash);

  while ($param) 
    {
      $param =~ /\s*(\w+)\s*=\s*\"([^\"]*)\"\s*(.*)/
	|| die "invalid parameter";
      my($value) = $2;
      my ($key);
      for $key (keys %def)
	{ 
	  $value =~ s/\@$key\@/$def{$key}/g;
	}
      $hash{$1} = $value;
      $param = $3;
    }
  return %hash;
}

die "usage 'hit.pl template definitions'" unless @ARGV >=2;

my(%def) = getdef($ARGV[1]);

open FILE, "<$ARGV[0]" || die "unable to open file : $ARGV[0]";

my($line);
while ($line = <FILE>)
  {
    if ($line=~/(.*)<!--\s*COMMAND\s*=\s*"([^\"]*)"(.*)-->(.*)/) 
      {
	print $1;
        my($cmd) = $2;
        my($param) = $3;
	my($trailer)=$4;

        if ($cmd=~/execute/)
	  {
	    my(%hash) = getparam($param, %def);
	    if (defined($hash{"PARAM"}))
	      {
	        print `$hash{"PARAM"}`;
	      }
	    else
              {
	        die "The execute command require PARAM = \".*\"";
	      }
	  }
        else
	  {
	    die "unrecognize command";;
	  }
	print $trailer;
      }
    else
      {
	print $line;
      }
  }

close FILE;
